Apache log4cxx: SMTPAppender Class Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# SMTPAppender Class Reference

Inherits AppenderSkeleton.

List of all members.

## Detailed Description

Send an e-mail when a specific logging event occurs, typically on errors or fatal errors.

The number of logging events delivered in this e-mail depend on the value of BufferSize option. The `SMTPAppender` keeps only the last `BufferSize` logging events in its cyclic buffer. This keeps memory requirements at a reasonable level while still delivering useful application context.

## Public Member Functions
| SMTPAppender ()
| SMTPAppender (log4cxx::helpers::Pool &p)
| The default constructor will instantiate the appender with a spi::TriggeringEventEvaluator that will trigger on events with level ERROR or higher.
| SMTPAppender (spi::TriggeringEventEvaluatorPtr evaluator)
| Use `evaluator` passed as parameter as the spi::TriggeringEventEvaluator for this net::SMTPAppender.
| ~SMTPAppender ()
virtual void | setOption (const LogString &option, const LogString &value)
| Set options.
virtual void | activateOptions (log4cxx::helpers::Pool &p)
| Activate the specified options, such as the smtp host, the recipient, from, etc.
virtual void | append (const spi::LoggingEventPtr &event, log4cxx::helpers::Pool &p)
| Perform SMTPAppender specific appending actions, mainly adding the event to a cyclic buffer and checking if the event triggers an e-mail to be sent.
virtual void | close ()
| Release any resources allocated within the appender such as file handles, network connections, etc.
LogString | getTo () const
| Returns value of the To option.
LogString | getCc () const
| Returns value of the cc option.
LogString | getBcc () const
| Returns value of the bcc option.
virtual bool | requiresLayout () const
| The `SMTPAppender` requires a layout.
void | sendBuffer (log4cxx::helpers::Pool &p)
| Send the contents of the cyclic buffer as an e-mail message.
LogString | getEvaluatorClass ()
| Returns value of the EvaluatorClass option.
LogString | getFrom () const
| Returns value of the From option.
LogString | getSubject () const
| Returns value of the Subject option.
void | setFrom (const LogString &from)
| The From option takes a string value which should be a e-mail address of the sender.
void | setSubject (const LogString &subject)
| The Subject option takes a string value which should be a the subject of the e-mail message.
void | setBufferSize (int bufferSize)
| The BufferSize option takes a positive integer representing the maximum number of logging events to collect in a cyclic buffer.
void | setSMTPHost (const LogString &smtpHost)
| The SMTPHost option takes a string value which should be a the host name of the SMTP server that will send the e-mail message.
LogString | getSMTPHost () const
| Returns value of the SMTPHost option.
void | setSMTPPort (int port)
| The SMTPPort option takes a string value which should be a the port of the SMTP server that will send the e-mail message.
int | getSMTPPort () const
| Returns value of the SMTPHost option.
void | setTo (const LogString &to)
| The To option takes a string value which should be a comma separated list of e-mail address of the recipients.
void | setCc (const LogString &to)
| The Cc option takes a string value which should be a comma separated list of e-mail address of the cc'd recipients.
void | setBcc (const LogString &to)
| The Bcc option takes a string value which should be a comma separated list of e-mail address of the bcc'd recipients.
void | setSMTPUsername (const LogString &newVal)
| The SMTPUsername option takes a string value which should be a the user name for the SMTP server.
LogString | getSMTPUsername () const
| Returns value of the SMTPUsername option.
void | setSMTPPassword (const LogString &newVal)
| The SMTPPassword option takes a string value which should be a the password for the SMTP server.
LogString | getSMTPPassword () const
| Returns value of the SMTPPassword option.
int | getBufferSize () const
| Returns value of the BufferSize option.
log4cxx::spi::TriggeringEventEvaluatorPtr | getEvaluator () const
| Gets the current triggering evaluator.
void | setEvaluator (log4cxx::spi::TriggeringEventEvaluatorPtr &trigger)
| Sets the triggering evaluator.
void | setEvaluatorClass (const LogString &value)
| The EvaluatorClass option takes a string value representing the name of the class implementing the spi::TriggeringEventEvaluator interface.
void | setLocationInfo (bool locationInfo)
| The LocationInfo option is provided for compatibility with log4j and has no effect in log4cxx.
bool | getLocationInfo () const
| Returns value of the LocationInfo option.

## Constructor & Destructor Documentation

SMTPAppender | ( |  | ) |

SMTPAppender | ( | log4cxx::helpers::Pool & | p | ) |

| The default constructor will instantiate the appender with a spi::TriggeringEventEvaluator that will trigger on events with level ERROR or higher.

SMTPAppender | ( | spi::TriggeringEventEvaluatorPtr | evaluator | ) |

| Use `evaluator` passed as parameter as the spi::TriggeringEventEvaluator for this net::SMTPAppender.

~SMTPAppender | ( |  | ) |

## Member Function Documentation

virtual void activateOptions | ( | log4cxx::helpers::Pool & | p | ) | `[virtual]`

| Activate the specified options, such as the smtp host, the recipient, from, etc. Reimplemented from AppenderSkeleton.

virtual void append | ( | const spi::LoggingEventPtr & | event,
|  | log4cxx::helpers::Pool & | p
| ) | `[virtual]`

| Perform SMTPAppender specific appending actions, mainly adding the event to a cyclic buffer and checking if the event triggers an e-mail to be sent. Implements AppenderSkeleton.

virtual void close | ( |  | ) | `[virtual]`

| Release any resources allocated within the appender such as file handles, network connections, etc. It is a programming error to append to a closed appender. Implements Appender.

LogString getBcc | ( |  | ) | const

| Returns value of the bcc option.

int getBufferSize | ( |  | ) | const`[inline]`

| Returns value of the BufferSize option.

LogString getCc | ( |  | ) | const

| Returns value of the cc option.

log4cxx::spi::TriggeringEventEvaluatorPtr getEvaluator | ( |  | ) | const

| Gets the current triggering evaluator. Returns: triggering evaluator.

LogString getEvaluatorClass | ( |  | ) |

| Returns value of the EvaluatorClass option.

LogString getFrom | ( |  | ) | const

| Returns value of the From option.

bool getLocationInfo | ( |  | ) | const

| Returns value of the LocationInfo option.

LogString getSMTPHost | ( |  | ) | const

| Returns value of the SMTPHost option.

LogString getSMTPPassword | ( |  | ) | const

| Returns value of the SMTPPassword option.

int getSMTPPort | ( |  | ) | const

| Returns value of the SMTPHost option.

LogString getSMTPUsername | ( |  | ) | const

| Returns value of the SMTPUsername option.

LogString getSubject | ( |  | ) | const

| Returns value of the Subject option.

LogString getTo | ( |  | ) | const

| Returns value of the To option.

virtual bool requiresLayout | ( |  | ) | const`[virtual]`

| The `SMTPAppender` requires a layout. Implements Appender.

void sendBuffer | ( | log4cxx::helpers::Pool & | p | ) |

| Send the contents of the cyclic buffer as an e-mail message.

void setBcc | ( | const LogString & | to | ) |

| The Bcc option takes a string value which should be a comma separated list of e-mail address of the bcc'd recipients.

void setBufferSize | ( | int | bufferSize | ) |

| The BufferSize option takes a positive integer representing the maximum number of logging events to collect in a cyclic buffer. When the `BufferSize` is reached, oldest events are deleted as new events are added to the buffer. By default the size of the cyclic buffer is 512 events.

void setCc | ( | const LogString & | to | ) |

| The Cc option takes a string value which should be a comma separated list of e-mail address of the cc'd recipients.

void setEvaluator | ( | log4cxx::spi::TriggeringEventEvaluatorPtr & | trigger | ) |

  | Sets the triggering evaluator. Parameters:
  | trigger | triggering evaluator.

void setEvaluatorClass | ( | const LogString & | value | ) |

| The EvaluatorClass option takes a string value representing the name of the class implementing the spi::TriggeringEventEvaluator interface. A corresponding object will be instantiated and assigned as the triggering event evaluator for the SMTPAppender.

void setFrom | ( | const LogString & | from | ) |

| The From option takes a string value which should be a e-mail address of the sender.

void setLocationInfo | ( | bool | locationInfo | ) |

| The LocationInfo option is provided for compatibility with log4j and has no effect in log4cxx.

virtual void setOption | ( | const LogString & | option,
|  | const LogString & | value
| ) | `[virtual]`

| Set options. Reimplemented from AppenderSkeleton.

void setSMTPHost | ( | const LogString & | smtpHost | ) |

| The SMTPHost option takes a string value which should be a the host name of the SMTP server that will send the e-mail message.

void setSMTPPassword | ( | const LogString & | newVal | ) |

| The SMTPPassword option takes a string value which should be a the password for the SMTP server.

void setSMTPPort | ( | int | port | ) |

| The SMTPPort option takes a string value which should be a the port of the SMTP server that will send the e-mail message.

void setSMTPUsername | ( | const LogString & | newVal | ) |

| The SMTPUsername option takes a string value which should be a the user name for the SMTP server.

void setSubject | ( | const LogString & | subject | ) |

| The Subject option takes a string value which should be a the subject of the e-mail message.

void setTo | ( | const LogString & | to | ) |

| The To option takes a string value which should be a comma separated list of e-mail address of the recipients.

The documentation for this class was generated from the following file:

- smtpappender.h